// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from metro_benchmark_msgs:msg/ComputeTime.idl
// generated code does not contain a copyright notice

#ifndef METRO_BENCHMARK_MSGS__MSG__DETAIL__COMPUTE_TIME__TRAITS_HPP_
#define METRO_BENCHMARK_MSGS__MSG__DETAIL__COMPUTE_TIME__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "metro_benchmark_msgs/msg/detail/compute_time__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'duration'
#include "builtin_interfaces/msg/detail/duration__traits.hpp"

namespace metro_benchmark_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ComputeTime & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: duration
  {
    out << "duration: ";
    to_flow_style_yaml(msg.duration, out);
    out << ", ";
  }

  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: parent_id
  {
    out << "parent_id: ";
    rosidl_generator_traits::value_to_yaml(msg.parent_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ComputeTime & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: duration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "duration:\n";
    to_block_style_yaml(msg.duration, out, indentation + 2);
  }

  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: parent_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "parent_id: ";
    rosidl_generator_traits::value_to_yaml(msg.parent_id, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ComputeTime & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace metro_benchmark_msgs

namespace rosidl_generator_traits
{

[[deprecated("use metro_benchmark_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const metro_benchmark_msgs::msg::ComputeTime & msg,
  std::ostream & out, size_t indentation = 0)
{
  metro_benchmark_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use metro_benchmark_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const metro_benchmark_msgs::msg::ComputeTime & msg)
{
  return metro_benchmark_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<metro_benchmark_msgs::msg::ComputeTime>()
{
  return "metro_benchmark_msgs::msg::ComputeTime";
}

template<>
inline const char * name<metro_benchmark_msgs::msg::ComputeTime>()
{
  return "metro_benchmark_msgs/msg/ComputeTime";
}

template<>
struct has_fixed_size<metro_benchmark_msgs::msg::ComputeTime>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<metro_benchmark_msgs::msg::ComputeTime>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<metro_benchmark_msgs::msg::ComputeTime>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // METRO_BENCHMARK_MSGS__MSG__DETAIL__COMPUTE_TIME__TRAITS_HPP_
